[<p align="right">->Back to directory</p>](0.directory.md)

# Download & Compile   

## Compilation environment requirements    
>golang >= 1.9

## Source download  
* Go command download (will automatically download the dependent library, if you directly download the source code will prompt the class library is missing)    
* 'go get' command cannot be executed. Please check if the machine is installed with Git service and set Go environment.  

```shell
go get -u github.com/xssed/owlcache  
```

#### ⚠⚠⚠If 'go mod' is ON in your go locale, you need to create a directory locally on your computer, enter the directory, and execute ` git clone https://github.com/xssed/owlcache.git `Command to download the source code.

## Build
* Enter the owlcache home directory and execute the compilation command (in gopath mode, enter the owlcache home directory of gopath directory, and in gomod mode, enter the local directory you created in the previous prompt)  
```shell
go build
```

## Run 
* Note that the owlcache.conf file should be in the same directory as the main program.    
* The .conf configuration file must be a uniform UTF-8 encoding.  
* Set the <Pass> option in the configuration file owlcache.conf.      

Linux  
>./owlcache

Windows (DOS)   
>owlcache

Other platforms run the above reference, the same reason.  

### Parameter help  
* You can check out the help before running. 
* Note that the runtime configuration parameters take precedence over the configuration parameters in the *.conf file.

>owlcache -help

```shell
Welcome to use owlcache. Version:XXX
If you have any questions,Please contact us: xsser@xsser.cc
Project Home:https://github.com/xssed/owlcache
                _                _
   _____      _| | ___ __ _  ___| |__   ___
  / _ \ \ /\ / / |/ __/ _' |/ __| '_ \ / _ \
 | (_) \ V  V /| | (_| (_| | (__| | | |  __/
  \___/ \_/\_/ |_|\___\__,_|\___|_| |_|\___|

Usage of owlcache:
  -config string
        owlcache config file path.[demo:/var/home/owl.conf] (default "owlcache.conf")
  -host string
        binding local host ip address. (default "0.0.0.0")
  -log string
        owlcache log file path.[demo:/var/log/] (default "./log_file/")
  -pass string
        owlcache Http connection password. (default "")
```

Example with configuration parameter run  
```shell
owlcache -config /var/home/owl.conf -host 127.0.0.1 -log /var/log/ -pass 1245!df2A
```





  
