[<p align="right">->Back to directory</p>](0.directory.md)

## TCP Request
TCP communication adopts a text communication protocol similar to Memcache. The protocol format is `command + space + ...\n`.
For example, set a key value `set hello world\n`.


## HTTP request
HTTP communication uses the standard Http communication protocol. GET, POST...


## TCP&HTTP response
Except for the GET、PING command, the format of the unified response data is a Json string in the same format.
example:  
```shell
{
    "Cmd": "set",
    "Status": 200,
    "Results": "SUCCESS",
    "Key": "hello",
    "Data": "",
    "ResponseHost": "127.0.0.1:7721",
    "KeyCreateTime": "2021-11-09T14:22:42.2400755+08:00"
}  
```

|   parameter name |   meaning  |  
| --- | --- |
|   Cmd  |   Command to send the request  |
|   Status  |   Return status  |
|   Results  |  Return result   |
|   Key  |  Key name   |
|   Data  |   Return content  |
|   ResponseHost  |   Responding to host information  |
|   KeyCreateTime  |   The KEY value is created at the time, and if the non-query command returns, it may be an empty time.  |

### The response corresponds to Status and Results.  

|   Status  |   Results   |  meaning   |
| --- | --- | --- |
|  200    |  SUCCESS   |   normal  |
|  401    |  NOT_PASS   |   Unauthorized identity(or verification failed). Note: The TCP connection does not verify identity, so there is no such response.  |
|  404    |  NOT_FOUND   |   Did not find the data you want.   |
|  500    |  ERROR    |   Operation error.  |
|  501    |  UNKNOWN_COMMAND    |   Operation command not recognized.  |  

**When the <get> command of owlcache is requested by HTTP, the protocol response value of owl will overwrite the HTTP response value.**