[<p align="right">->Back to directory</p>](0.directory.md)

# Cluster configuration  
>⚠⚠⚠When adding and modifying data, it is recommended to follow the HTTP protocol and use a professional client for post submission to avoid data inconsistency caused by transmission coding. This is just a demonstration.  

* HTTP
Note: All operations related to cluster configuration require identity verification.

#### Get all nodes in the cluster  

<table>
    <tr>
        <td>Request parameter</td>
        <td>Parameter value</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>getall</td>
    </tr>
    <tr>
        <td>token</td>
        <td>token value</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=getall&group_type=owlcache&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

Response result:
~~~shell
{
    "Cmd": "getall",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "",
    "Data": [
        {
            "Cmd": "",
            "Address": "127.0.0.1:7721",
            "Pass": "",
            "Token": ""
        },
        {
            "Cmd": "",
            "Address": "127.0.0.1:7723",
            "Pass": "",
            "Token": ""
        },
        {
            "Cmd": "",
            "Address": "127.0.0.1:7725",
            "Pass": "",
            "Token": ""
        }
    ]
}
~~~


#### Get the configuration information of a node in the cluster  

<table>
    <tr>
        <td>Request parameter</td>
        <td>Parameter value</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>get</td>
    </tr>
    <tr>
        <td>address</td>
        <td>address information</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token value</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=get&group_type=owlcache&address=127.0.0.1:7721&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

Response result:
~~~shell
{
    "Cmd": "get",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:7721",
    "Data": {
        "Cmd": "",
        "Address": "127.0.0.1:7721",
        "Pass": "",
        "Token": ""
    }
}
~~~  

#### Add configuration information of a node  

<table>
    <tr>
        <td>Request parameter</td>
        <td>Parameter value</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>add</td>
    </tr>
    <tr>
        <td>address</td>
        <td>address information</td>
    </tr> 
    <tr>
        <td>pass</td>
        <td>password</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token value</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=add&group_type=owlcache&address=127.0.0.1:8080&pass=shi!jie9he?ping6&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

Response result:
~~~shell
{
    "Cmd": "",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:8080",
    "Data": null
}
~~~

#### Delete the configuration information of a node  

<table>
    <tr>
        <td>Request parameter</td>
        <td>Parameter value</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>delete</td>
    </tr>
    <tr>
        <td>address</td>
        <td>address information</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token value</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=delete&group_type=owlcache&address=127.0.0.1:8080&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

Response result:
~~~shell
{
    "Cmd": "delete",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:8080",
    "Data": null
}
~~~  
If you find it troublesome to configure via HTTP protocol, you can directly edit the file `server_group_config.json`. When owlcache starts, the cluster configuration information will be loaded.


# The cluster mode and the introduction of the two cluster modes   
> If you want to use the cluster mode of websocket communication, your owlcache version must satisfy >=0.4.3  
We find the [GroupData_Mode] section in the configuration file. to set it up.    
* The owlcache cluster mode is divided into "Http" (non-persistent connection) and "Websocket" (persistent connection). There are two options. The default is "Http" non-persistent connection.  
* "Http" (non-persistent connection) to find the [HttpGroupData] configuration  
* "Websocket" (persistent connection) to find the [Websocket_Client] configuration  
>GroupData_Mode Http
Replace `Http` of `GroupData_Mode` with `Websocket`   
Some people here will question what is the difference between "Http" (non-persistent connection) and "Websocket" (persistent connection)?    
When querying data in the cluster, you can set up "Websocket" (persistent connection) if there is high concurrency and real-time query data. However, the number of responses to queries in the "Websocket" cluster mode is much lower than that in the "Http" cluster mode.      
The "Http" cluster mode provides a second-level cache, which improves efficiency. If there is no connection error between cluster services similar to the following in the log when you use it, you can continue to use the "Http" cluster method.    
>[{"message":[["owlclient method GetValue error:Post http://127.0.0.1:7727/data/?cmd=get\u0026key=hello: dial tcp 127.0.0.1:7727: connectex: No connection could be made because the target machine actively refused it."]],"time":"2022-01-13T16:46:48.8880053+08:00"}]
>[{"message":[["owlclient method GetValue error:Post http://127.0.0.1:7721/data/?cmd=get\u0026key=hello: net/http: request canceled (Client.Timeout exceeded while awaiting headers)"]],"time":"2022-01-13T16:53:16.3804841+08:00"}]


# Cluster data synchronization configuration
* owlcache uses the Gossip protocol to achieve data synchronization between clusters. The author believes that loose synchronization will make the cluster more efficient.
* The Gossip protocol is a solution for eventual data consistency.
* The cluster information needs to be configured at startup, but the configuration is easy and simple.
* The data of each node will be automatically updated to the latest, although there is a delay, but the time is very short.


>Below we demonstrate how to configure a Gossip data exchange cluster. Suppose you plan to run three Owlcache Gossip services: 127.0.0.1:7726, 127.0.0.1:7727, 127.0.0.1:7728. <br>
(1) Set the GroupDataSync option in the owlcache.conf file to 1, and start the service<br>
(2) Change the Gossipport options in the owlcache.conf files of the three services to `7726`, `7727`, and `7728`<br>
(3) When Gossip serves a cluster, nodes need to authenticate their identity for data exchange. You need to set the <GossipDataSyncAuthKey> option value in the three owlcache.conf files to a uniform password. <br>
(4) Manually write the Gossip service cluster configuration file `server_group_gossip_config.json`<br>
~~~shell
[
	{
		"Cmd": "",
		"Address": "127.0.0.1:7726",
		"Pass": "",
		"Token": ""
	},
	{
		"Cmd": "",
		"Address": "127.0.0.1:7727",
		"Pass": "",
		"Token": ""
	},
	{
		"Cmd": "",
		"Address": "127.0.0.1:7728",
		"Pass": "",
		"Token": ""
	}
]
~~~  
(5)Put the `server_group_gossip_config.json` file into the data file directory (depending on the setting of the DBfile option in the configuration file), and then start the node.
In this way, the cluster is configured. When owlcache starts, the cluster configuration information will be loaded. The nodes will automatically contact each other. Assuming that node one is down, node two and node three will still maintain communication and update data.

>☆☆☆Of course, you can also configure the Gossip cluster through the HTTP protocol. Refer to the cluster configuration information and modify the HTTP request field `group_type` to `gossip`. 
