[<p align="right">->Back to directory</p>](0.directory.md)

## UrlCache (Url data import)
We find the [Url_Cache] section in the configuration file. To set it up.  

## [Url_Cache]
### Enable importing data from URL address
* Cache the HTTP response data obtained after URL proxy access to owlcache
* The values are "1" (open service) and "0" (close service). The default is 0 to turn off the service.  
>Open_Urlcache 0

### The name of the configuration file that needs to be loaded after URL caching is enabled
* The format is XML, it exists in the DBfile configuration item directory, and the default name is sites.xml.
>Urlcache_Filename sites.xml

### Enable quick access to Urlcache
* Does not affect the default access method of UrlCache.
* Values are "1" (on) and "0" (off). The default is 0 to close.  
>Urlcache_Request_Easy 0



## Description of the configuration file sites.xml
```markdown
<?xml version='1.0' encoding='UTF-8'?>
<!--Urlcache standard config profile -->
<sites>
    <site>
        <!--host: the base URL of the URL that needs to be mapped. Required. The default value is empty. Example: https://www.xsser.cc-->
        <host></host>
        <!--header:When a GET request is sent to the mapped web address, the subitem of the current HTTP request `request headers` will be forwarded to the mapped web address. The default is empty.-->
        <!--<header>-->
        <!--<value>User-Agent</value>-->
        <!--<value>Cookie</value>-->
        <!--</header>-->
        <!--max_storage_limit:The maximum number of bytes allowed in memory for the data returned by the mapping request. The unit is byte. The default maximum value is 5242880byte - > 5M -->
        <max_storage_limit></max_storage_limit>
        <!--check_token:Whether to verify the token of owl. The default is 0. 0 is off and 1 is on.-->
        <check_token></check_token>
        <!--key_expire:The effective time stored in memory. The unit is seconds. The default value is 0. 0 is permanent.-->
        <key_expire>3</key_expire>
        <!--timeout:Timeout for mapping requests. The unit is milliseconds. Default 5000ms - > 5S -->
        <timeout></timeout>
        <!--proxy:The proxy server that maps the request. The default is empty.Example: 77.77.77.77:7070  -->
        <proxy></proxy>
    </site>
</sites>
```

## Start accessing Urlcache
Assuming that the value of `<host>` in the configuration file `sites.xml`, we set the value to be `http://xsser.cc`, we visit the following address   
~~~shell
http://127.0.0.1:7721/uc/?cmd=get&key=/77.jpg&uc_site=0
~~~
* In fact, we visited `http://xsser.cc/77.jpg` and stored the data in owlcache. If the database exists in the next visit, the data will be returned directly.     
* You can also access the data stored in the local cache like this `http://127.0.0.1:7721/data/?cmd=get&key=/77.jpg`   
* The design idea of Url cache is to cache text-type interface data. Although the underlying storage of owlcache is byte data type, it is unreasonable for a large number of resource files to be stored in memory. Of course this is just a suggestion, you can use it according to actual usage scenarios.       

The uc_site parameter is the index value of `<site>` in `sites.xml`, so Url cache allows you to configure multiple site interfaces, it can be omitted, the default is 0, you can write like this         
~~~shell
http://127.0.0.1:7721/uc/?cmd=get&key=/77.jpg
~~~

If the value of `Urlcache_Request_Easy` in the .conf file of owlcache is `0`, you can also access like this  
~~~shell
http://127.0.0.1:7721/77.jpg
~~~
Warning: The quick access method will invalidate the `uc_site` parameter.     

Assuming that you have a specific interface request parameter that needs to be submitted to access this interface correctly, you can access the Url Cache through an HTTP POST request, and add the corresponding one agreed in the configuration item `<header>` in the request message data. owlcache still accesses the interface through a GET request, but forwards the message.    

Note: If the parameter `token` in the key address of urlcache and the `token` of owl are duplicated, causing conflicts, you can replace the `token` of owl with `owl_token`.       

   