[<p align="right">->Back to directory</p>](../0.directory.md)

# Get the Key value
* TCP
command: `get <key>\n`
~~~shell
get hello\n
~~~

* HTTP
Note: HTTP access data is not verified by password, only other operations that change data require authentication.

<table>
    <tr>
        <td>parameter name</td>
        <td>parameter value</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>get</td>
    </tr>
    <tr>
        <td>key</td>
        <td>key name</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/data/?cmd=get&key=hello
~~~

* Websocket
command: `get <key>`
~~~shell
get hello
~~~

<br>

Response result example:
~~~shell
world
~~~
If it is an HTTP request, there will be Key details in the response message.  
Key: hello  
Keycreatetime: 2021-11-26 18:12:45.1932019 +0800 CST  
Responsehost: 127.0.0.1:7721  


# Get the Key value info
* TCP
command: `get <key> info\n`
~~~shell
get hello info\n
~~~

* HTTP
>owlcache version >= 0.4.2, http no longer supports 'info'

~~`http://127.0.0.1:7721/data/?cmd=get&key=hello&valuedata=info`~~

* Websocket
command: `get <key> info <Custom return string (not necessary, such as UUID)>`
~~~shell
get hello info
~~~
or
~~~shell
get hello info 5c9eff00-3bed-4113-a095-2f3c771683d9
~~~

Response result example:
~~~shell
{
    "Cmd": "get",
    "Status": 200,
    "Results": "SUCCESS",
    "Key": "hello",
    "Data": "d29ybGQ=",
    "ResponseHost": "127.0.0.1:7721",
    "KeyCreateTime": "2021-11-09T14:12:36.8431596+08:00"
}
~~~

**Attention to the HTTP Status code returned by the HTTP Request. please refer to the "Protocol" chapter.**