[<p align="right">->Back to directory</p>](../0.directory.md)  

# Set expiration time for a Key

* TCP
Command: `expire <key> <seconds>\n`
Note: The unit of seconds is seconds. All key values are permanent data when stored in the set command.
~~~shell
expire hello 60\n
~~~

* HTTP
>⚠⚠⚠When adding and modifying data, it is recommended to follow the HTTP protocol and use a professional client for post submission to avoid data inconsistency caused by transmission coding. This is just a demonstration.  


<table>
    <tr>
        <td>parameter name</td>
        <td>parameter value</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>expire</td>
    </tr>
    <tr>
        <td>key</td>
        <td>key name</td>
    </tr> 
    <tr>
        <td>exptime</td>
        <td>Time value, int type, seconds.</td>
    </tr>
    <tr>
        <td>token</td>
        <td>token value</td>
    </tr>
</table> 

~~~shell
http://127.0.0.1:7721/data/?cmd=expire&key=hello&exptime=30&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

Response result example:
~~~shell
{
    "Cmd": "expire",
    "Status": 200,
    "Results": "SUCCESS",
    "Key": "hello",
    "Data": null,
    "ResponseHost": "127.0.0.1:7721",
    "KeyCreateTime": "0001-01-01T00:00:00Z"
}
~~~