[<p align="right">->返回目录</p>](0.directory.md)

# owlcache 配置文件
* 程序启动时，您动态配置的参数会覆盖掉*.conf文件中的参数

## 配置文件书写约定
>1.以#开头表示这一行是注释内容  
>2.以[]表示分组信息(更直观的展示配置信息)  
>3.配置参数名与参数值以一个空格间隔。  

## [Owlcache]
### 设置程序监听的IP
* 如果您正常启动后无法访问服务，请检查下防火墙之类的软件是否限制了您的访问
>Host 0.0.0.0

### 设置程序响应IP
* 默认本机
* 在TCP、HTTP返回的响应结果Json字符串中使用，注意局域网、外网环境中实际部署时IP的正确性!
>ResponseHost 127.0.0.1

### 日志文件路径
* 默认日志会生成到服务运行目录
* !!!如果在命令行中启动服务时指定了Logfile值，而配置文件这里没有注释掉则会以配置文件为准
>Logfile ./log_file/

### 数据库文件路径
* 默认数据库文件会生成到服务运行目录
>DBfile ./db_file/


## [TCP]
### TCP监听端口
* 默认为7720
* 如果不填写或者端口值为0 则默认监听7720端口
>Tcpport 7720

### 是否开启Tcp服务
* TCP模式下无密码认证(生产环境部署请根据实际情况屏蔽TCP的访问端口等等，注意使用安全)
* 值为"1"(开启服务)和"0"(关闭服务)。默认为1开启服务。
>CloseTcp 1


## [HTTP]
### HTTP监听端口
* 默认为7721。
* 如果不填写或者端口值为0 则默认监听7721端口.
>Httpport 7721

### HTTP密码
* 强制且必须的，不要设置的过于简单
* 请设置密码。密码要求长度不能低于十位数，不能是纯数字，建议采用大写字母+小写字母+数字+简单符号
>Pass 

### Tonken过期时间
* 为"Pass"命令产生的Tonken值设置一个过期时间。
* 默认为0。单位是秒。如果值为0，则永不过期。
* 警告:设置永不过期，也许会存在安全风险。
>Tonken_expire_time 0

### HTTPS相关配置
* Open_Https 是否开启HTTPS。值为0(关闭)、1(开启)。默认关闭。
* Https_CertFile Cert文件路径。例如:/www/server.crt、D:/key/server.crt。
* Https_KeyFile Key文件路径。例如:/www/server.key、D:/key/server.key。
* HttpsClient_InsecureSkipVerify 当开启HTTPS模式后，owlcache之间互相通讯时是否校验证书合法性。值为0(关闭)、1(开启)。默认关闭。开启时不会校验证书合法性。
>Open_Https 0

>Https_CertFile /www/server.crt

>Https_KeyFile /www/server.key

>HttpsClient_InsecureSkipVerify 0

### 跨域相关配置
* "跨域资源共享"(Cross-origin resource sharing)配置。
* Cors值为"1"(开启服务)和"0"(关闭服务)。默认为0关闭服务不允许跨域。
* Access_Control_Allow_Origin值默认为"*"(允许所有域的请求)。您可以将此值设置为您指定的域。
* 注意:谨慎设置小心CSRF攻击。
>Cors 0

>Access_Control_Allow_Origin *


## [HttpGroupData]
### 集群互相通信时的请求超时时间
* 单位毫秒。默认2700毫秒超时。实际上内网环境的数据互通时间很低,可以根据实际情况来设置。
>HttpClientRequestTimeout 2700

### Http客户端请求设置
* 请求得到得数据将会短时间缓存在本地,避免同一个Key在高并发状态下反复对其他节点疯狂查询。适当的延迟查询有助于性能和效率得优化。
* 单位毫秒，默认这个缓存生命周期为5000毫秒。值为0则不进行缓存(适合并发量小，数据实时性要求高的场景)。
>HttpClientRequestLocalCacheLifeTime 5000


## [GroupDataSync]

### 是否开启集群数据同步
* 0表示不开启。1表示开启。默认不开启。
>GroupDataSync 0

### 设置Gossip监听端口
* 启用集群数据同步服务该项才会生效。
* 集群数据同步服务依赖于Gossip协议。建议不设置该项,系统会自动进行分配端口。默认值为0(系统自动监听一个端口并在启动信息输出该端口)。
>Gossipport 0

### 整个Gossip集群需要统一的令牌
* 启用集群数据同步服务该项才会生效。
* 集群中通过Gossip协议交换数据的令牌。默认为空，你需要为集群设置一个相同密码。
>GossipDataSyncAuthKey 

### 集群同步数据互相通信时的请求超时时间
* 单位毫秒。默认5000毫秒超时。实际上内网环境的数据互通时间很低,可以根据实际情况来设置。
>GossipHttpClientRequestTimeout 5000


## [Memcache_Client]
### 开启从memcache导入数据
* 是否开启查询不存在的数据时,从memcache查询并存入本地数据库。0表示不开启。
>Get_data_from_memcache 0

### 查询的memcache列表
* 不同节点之间需要使用"|"符号间隔。例如:127.0.0.1:11211|192.168.0.77:11211。默认为空值。
>Memcache_list 

### 导入数据的过期时间
* 为从memcache存入本地数据库的Key设置一个过期时间。默认为0，永久不过期。单位是秒。
>Get_memcache_data_set_expire_time 0

### MemcacheClient客户端请求设置
* Max_Error_Number超过限定值时，MemcacheClient请求将“暂停”Sleeptime值，来优化程序响应速度。
* Sleeptime代表睡眠时间，单位秒，默认最低睡眠2秒。
* Max_Error_Number代表最大失败请求数，单位是整数，默认最小错误请求2次。
>MemcacheClient_Request_Timeout_Sleeptime 2

>MemcacheClient_Request_Max_Error_Number 2


## [Redis_Client]
### 开启从Redis导入数据
* 是否开启查询不存在的数据时,从redis查询并存入本地数据库。0表示不开启。
>Get_data_from_redis 0

### 需要查询的Redis地址
* 不能是空值。  
>Redis_Addr 

### 需要查询的Redis密码
* 不能是空值。  
>Redis_Password 

### 需要查询Redis的数据库
* 默认为0
>Redis_DB 0

### 导入数据的过期时间
* 为从Redis存入本地数据库的Key设置一个过期时间。默认为0，永久不过期。单位是秒。
>Get_redis_data_set_expire_time 0

### RedisClient客户端请求设置
* RedisClient客户端请求设置。Max_Error_Number超过限定值时，RedisClient请求将“暂停”Sleeptime值，来优化程序响应速度。
* Sleeptime代表睡眠时间，单位秒，默认最低睡眠2秒。
* Max_Error_Number代表最大失败请求数，单位是整数，默认最小错误请求2次。
>RedisClient_Request_Timeout_Sleeptime 2

>RedisClient_Request_Max_Error_Number 2


## [Url_Cache]
### 开启从URL地址导入数据
* URL代理访问后将得到的HTTP响应数据缓存到Owlcache中
* 值为"1"(开启服务)和"0"(关闭服务)。默认为0关闭服务。
>Open_Urlcache 0

### 开启URL缓存后的需要加载的配置文件的名称
* 格式为XML，它存在于DBfile配置项目录中，默认名称为sites.xml。
>Urlcache_Filename sites.xml

### 开启Urlcache的快捷访问
* 不影响UrlCache的默认访问方式。
* 值为"1"(开启)和"0"(关闭)。默认为0关闭。
>Urlcache_Request_Easy 0


## [Task]
### 定时配置-自动备份DB数据的存储时间
* 单位分钟。默认为1.
* 警告:如果数据库中数据非常多,重新启动服务时,假如数据重新装载到内存的时间，超过了设置的备份时间就会导致数据实体文件被覆盖掉，这是非常严重的数据丢失错误。  
>Task_DataBackup 1

### 定时配置-自动备份用户认证数据的存储时间
* 单位分钟。默认为1.
* 警告:如果数据库中数据非常多,重新启动服务时,假如数据重新装载到内存的时间，超过了设置的备份时间就会导致数据实体文件被覆盖掉，这是非常严重的数据丢失错误。  
>Task_DataAuthBackup 1

### 定时配置-自动清理数据库中过期数据的时间
* 单位分钟。默认为1.
>Task_ClearExpireData 1

### 定时配置-自动备份服务器集群信息数据的时间
* 单位分钟。默认为1.
* 警告:如果数据库中数据非常多,重新启动服务时,假如数据重新装载到内存的时间，超过了设置的备份时间就会导致数据实体文件被覆盖掉，这是非常严重的数据丢失错误。  
>Task_ServerListBackup 1

### 定时配置-自动备份Gossip服务集群信息的时间
* 单位分钟。默认为1.
* 警告:如果数据库中数据非常多,重新启动服务时,假如数据重新装载到内存的时间，超过了设置的备份时间就会导致数据实体文件被覆盖掉，这是非常严重的数据丢失错误。  
>Task_ServerGossipListBackup 1

### 定时配置-自动输出Owl的内存信息
* 单位分钟。默认为1.  
>Task_MemoryInfoToLog 1

### 开启Task执行成功日志输出。值为1，输出日志，其他任何值则会屏蔽日志。  
>Task_OutputSuccessLog 1