[<p align="right">->返回目录</p>](0.directory.md)

## TCP请求
TCP通讯采取类似Memcache的文本通讯协议 协议格式为`命令+空格 + ...\n`的方式。  
例如设置一个键值`set hello world\n`。  


## HTTP请求
HTTP通讯就是采用标准的Http通讯协议。GET、POST......


## TCP&HTTP响应
除了GET、PING命令之外，统一响应数据的格式为同格式Json字符串。  
例:  
```shell
{
    "Cmd": "set",
    "Status": 200,
    "Results": "SUCCESS",
    "Key": "hello",
    "Data": "",
    "ResponseHost": "127.0.0.1:7721",
    "KeyCreateTime": "2021-11-09T14:22:42.2400755+08:00"
} 
```

|   键名 |   含义  |
| --- | --- |
|   Cmd  |   发送请求的命令  |
|   Status  |   返回状态  |
|   Results  |  返回结果   |
|   Key  |  操作的Key名   |
|   Data  |   返回内容  |
|   ResponseHost  |   响应主机信息  |
|   KeyCreateTime  |   KEY值创建时间,如果非查询命令返回的可能是个空时间。  |

### 响应中Status与Results是对应的  

|   Status  |   Results   |  含义   |
| --- | --- | --- |
|  200    |  SUCCESS   |   正常  |
|  401    |  NOT_PASS   |   身份未授权(或者验证失败)。注意:TCP连接不验证身份,故无此响应。  |
|  404    |  NOT_FOUND   |   没有找到你要的数据   |
|  500    |  ERROR    |   出错  |
|  501    |  UNKNOWN_COMMAND    |   操作命令未识别  |  

**owlcache的<get>命令在用HTTP方式请求时，owl的协议响应值会将HTTP响应值覆盖。**