[<p align="right">->返回目录</p>](0.directory.md)

# 集群配置  
>⚠⚠⚠在添加和修改数据时，建议遵循HTTP协议，并使用专业客户端进行后期提交，以避免传输编码导致数据不一致。这只是一个示范。  

* HTTP
注意:所有集群配置相关的操作都需要验证身份。

#### 获取集群中所有节点  

<table>
    <tr>
        <td>请求参数</td>
        <td>参数值</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>getall</td>
    </tr>
    <tr>
        <td>token</td>
        <td>token值</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=getall&group_type=owlcache&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

响应结果例子:
~~~shell
{
    "Cmd": "getall",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "",
    "Data": [
        {
            "Cmd": "",
            "Address": "127.0.0.1:7721",
            "Pass": "",
            "Token": ""
        },
        {
            "Cmd": "",
            "Address": "127.0.0.1:7723",
            "Pass": "",
            "Token": ""
        },
        {
            "Cmd": "",
            "Address": "127.0.0.1:7725",
            "Pass": "",
            "Token": ""
        }
    ]
}
~~~


#### 获取集群中一个节点的配置信息  

<table>
    <tr>
        <td>请求参数</td>
        <td>参数值</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>get</td>
    </tr>
    <tr>
        <td>address</td>
        <td>节点地址</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token值</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=get&group_type=owlcache&address=127.0.0.1:7721&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

响应结果例子:
~~~shell
{
    "Cmd": "get",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:7721",
    "Data": {
        "Cmd": "",
        "Address": "127.0.0.1:7721",
        "Pass": "",
        "Token": ""
    }
}
~~~  

#### 增加一个节点的配置信息  

<table>
    <tr>
        <td>请求参数</td>
        <td>参数值</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>add</td>
    </tr>
    <tr>
        <td>address</td>
        <td>节点地址</td>
    </tr> 
    <tr>
        <td>pass</td>
        <td>节点的连接密码</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token值</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=add&group_type=owlcache&address=127.0.0.1:8080&pass=shi!jie9he?ping6&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

响应结果例子:
~~~shell
{
    "Cmd": "",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:8080",
    "Data": null
}
~~~

#### 删除一个节点的配置信息  

<table>
    <tr>
        <td>请求参数</td>
        <td>参数值</td>
    </tr>
    <tr>
        <td>group_type</td>
        <td>owlcache</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>delete</td>
    </tr>
    <tr>
        <td>address</td>
        <td>节点地址</td>
    </tr> 
    <tr>
        <td>token</td>
        <td>token值</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/server/?cmd=delete&group_type=owlcache&address=127.0.0.1:8080&token=MDZhZDYzYzZkOTYwYjM3YTFlY2M0NTVhZWZjMzJkNmU=
~~~
<br>

响应结果例子:
~~~shell
{
    "Cmd": "delete",
    "Status": 200,
    "Results": "SUCCESS",
    "Address": "127.0.0.1:8080",
    "Data": null
}
~~~  
如果你觉得通过HTTP协议配置很麻烦，你可以直接编辑文件`server_group_config.json`。在owlcache启动时，集群配置信息会被加载。


# 集群的方式和两种集群方式的介绍  
> 如果你要使用websocket通讯的集群方式，你的owlcache的版本必须满足>=0.4.3  
我们找到配置文件中的[GroupData_Mode]部分。来设置它。  
* owlcache集群方式，分为“Http”(短链接)和“Websocket”(长链接)，两个选项，默认是“Http”短链接。
* “Http”(短链接)去寻找[HttpGroupData]配置
* “Websocket”(长链接)去寻找[Websocket_Client]配置
>GroupData_Mode Http
将` GroupData_Mode`的`Http`更换为`Websocket`   
这里会有人疑问“Http”(短链接)和“Websocket”(长链接)的区别是什么？  
在集群查询数据时，如果高并发状态，且实时查询数据你可以设置“Websocket”(长链接)。但是“Websocket”集群方式查询的响应次数远远低于“Http”的集群方式。    
“Http”的集群方式提供了二级缓存，效率提升。如果你在使用时日志没有出现下面类似的集群服务之间的连接错误，你可以继续使用“Http”的集群方式。  
>[{"message":[["owlclient method GetValue error:Post http://127.0.0.1:7727/data/?cmd=get\u0026key=hello: dial tcp 127.0.0.1:7727: connectex: No connection could be made because the target machine actively refused it."]],"time":"2022-01-13T16:46:48.8880053+08:00"}]
>[{"message":[["owlclient method GetValue error:Post http://127.0.0.1:7721/data/?cmd=get\u0026key=hello: net/http: request canceled (Client.Timeout exceeded while awaiting headers)"]],"time":"2022-01-13T16:53:16.3804841+08:00"}]


# 集群数据同步配置  
* owlcache采用Gossip协议来实现集群间的数据同步,作者认为松散的同步会让集群效率更高。
* Gossip协议是一个数据最终一致性的解决方案。
* 需要在启动时就配置好集群信息，但是配置轻松简单。
* 每个节点的数据会自动更新到最新，虽然有延时，但是时间很短。  
  

>下面我们演示如何配置Gossip数据交换集群。假设现在计划运行三个Owlcache Gossip服务:127.0.0.1:7726、127.0.0.1:7727、127.0.0.1:7728。<br>
(1)把owlcache.conf文件中的GroupDataSync选项设置为1，开启服务<br>
(2)把三个服务的owlcache.conf文件中的Gossipport选项分别为`7726`、`7727`、`7728`<br>
(3)Gossip服务集群时,节点进行数据交换是需要认证身份的。需要把三个owlcache.conf文件中的<GossipDataSyncAuthKey>选项值设置为统一的密码。<br>
(4)手工编写Gossip服务集群配置文件 `server_group_gossip_config.json`<br>
~~~shell
[
	{
		"Cmd": "",
		"Address": "127.0.0.1:7726",
		"Pass": "",
		"Token": ""
	},
	{
		"Cmd": "",
		"Address": "127.0.0.1:7727",
		"Pass": "",
		"Token": ""
	},
	{
		"Cmd": "",
		"Address": "127.0.0.1:7728",
		"Pass": "",
		"Token": ""
	}
]
~~~  
(5)将 `server_group_gossip_config.json` 文件放入数据文件目录(取决于配置文件中DBfile选项的设置)，然后启动节点。 
这样集群就配置好了，在owlcache启动时，集群配置信息会被加载。节点之间会自动联系，假设现在节点一宕机，节点二与节点三仍然会保持通讯，更新数据。  

>☆☆☆当然你也可以通过HTTP协议配置Gossip集群。参照集群配置信息，将HTTP请求字段group_type修改为gossip  
