[<p align="right">->返回目录</p>](0.directory.md)

## UrlCache(Url数据导入)
我们找到配置文件中的[Url_Cache]部分。来设置它。  

## [Url_Cache]
### 开启从URL地址导入数据
* URL代理访问后将得到的HTTP响应数据缓存到Owlcache中
* 值为"1"(开启服务)和"0"(关闭服务)。默认为0关闭服务。
>Open_Urlcache 0

### 开启URL缓存后的需要加载的配置文件的名称
* 格式为XML，它存在于DBfile配置项目录中，默认名称为sites.xml。
>Urlcache_Filename sites.xml

### 开启Urlcache的快捷访问
* 不影响UrlCache的默认访问方式。
* 值为"1"(开启)和"0"(关闭)。默认为0关闭。
>Urlcache_Request_Easy 0



## 配置文件sites.xml的说明
```markdown
<?xml version='1.0' encoding='UTF-8'?>
<!--UrlCache 标准配置文件-->
<sites>
    <site>
        <!--host:需要映射的URL基础网址。必填项。默认为空。例:https://www.xsser.cc-->
        <host>http://xsser.cc</host>
        <!--header:向映射网址发送GET访问请求时，将会把当前HTTP请求Request headers的子项附带转发到映射网址。默认为空。-->
        <!--<header>-->
        <!--<value>User-Agent</value>-->
        <!--<value>Cookie</value>-->
        <!--</header>-->
        <!--max_storage_limit:映射请求返回的数据在内存中允许的最大存储字节数。单位byte。默认最大值得为5242880byte->5M -->
        <max_storage_limit></max_storage_limit>
        <!--check_token:是否要校验owl的token。默认为0 。0为关闭，1为开启。-->
        <check_token></check_token>
        <!--key_expire:存储在内存的有效时间。单位秒。默认为0。0为永久。-->
        <key_expire></key_expire>
        <!--timeout:映射请求的超时时间。单位毫秒。默认5000ms->5s-->
        <timeout></timeout>
        <!--proxy:映射请求的代理服务器。默认为空 -->
        <proxy></proxy>
    </site>
<!--<site></site>-->
</sites>
```

## 开始访问Urlcache
假设配置文件`sites.xml`中的` <host>` 值我们设置的值是` http://xsser.cc`，我们访问下面的地址   
~~~shell
http://127.0.0.1:7721/uc/?cmd=get&key=/77.jpg&uc_site=0
~~~
* 实际上我们访问了`http://xsser.cc/77.jpg`然后将数据存储在owlcache中，下次访问如果数据库中存在则直接将数据返回。   
* 存储在本地缓存数据你也可以这样访问`http://127.0.0.1:7721/data/?cmd=get&key=/77.jpg`   
* Url cache的设计想法是缓存文本类型的接口数据，虽然owlcache底层存储的是byte数据类型，但是大量的资源文件存储在内存中是不合理的。当然这只是一个建议,你可以根据实际使用场景来使用。     

uc_site参数是`sites.xml`中的` <site>`索引值，所以Url cache是允许你配置多个站点接口，它是可以省略的，默认为0，你可以写成这样       
~~~shell
http://127.0.0.1:7721/uc/?cmd=get&key=/77.jpg
~~~

如果owlcache的.conf文件中`Urlcache_Request_Easy`值为`0`，你也可以这样访问  
~~~shell
http://127.0.0.1:7721/77.jpg
~~~
警告:快捷访问的方式会让`uc_site`参数失效。   

假设你有特定的接口请求参数需要提交才可以正确访问这个接口，你可以通过HTTP POST的请求来访问Url Cache,并在请求报文中添加事先在配置项`<header>`约定好的对应的数据。owlcache还是通过GET请求方式去访问接口，只不过对报文进行了转发。     

注意:如果urlcache的key地址中参数`token`和owl的`token`产生了重复，造成冲突，你可以把owl的`token`更换为`owl_token`
