[<p align="right">->返回目录</p>](../0.directory.md)

# 获取Key值
* TCP
命令: `get <key>\n`
~~~shell
get hello\n
~~~

* HTTP
注意:HTTP获取数据不用密码验证，只有其他更改数据的操作需要验证身份。

<table>
    <tr>
        <td>请求参数</td>
        <td>参数值</td>
    </tr>
    <tr>
        <td>cmd</td>
        <td>get</td>
    </tr>
    <tr>
        <td>key</td>
        <td>key名称</td>
    </tr> 
</table> 
 
~~~shell
http://127.0.0.1:7721/data/?cmd=get&key=hello
~~~

* Websocket
命令: `get <key>`
~~~shell
get hello
~~~

<br>

响应结果例子:
~~~shell
world
~~~
如果是HTTP请求，在响应报文中会有Key的详细信息  
Key: hello  
Keycreatetime: 2021-11-26 18:12:45.1932019 +0800 CST  
Responsehost: 127.0.0.1:7721  


# 获取Key值的信息
* TCP
命令: `get <key> info\n`
~~~shell
get hello info\n
~~~

* HTTP
>owlcache version >= 0.4.2, http no longer supports 'info'

~~`http://127.0.0.1:7721/data/?cmd=get&key=hello&valuedata=info`~~

* Websocket
命令: `get <key> info <自定义返回字符串(非必要，例如UUID)>`
~~~shell
get hello info
~~~
或者
~~~shell
get hello info 5c9eff00-3bed-4113-a095-2f3c771683d9
~~~

响应结果例子:
~~~shell
{
    "Cmd": "get",
    "Status": 200,
    "Results": "SUCCESS",
    "Key": "hello",
    "Data": "d29ybGQ=",
    "ResponseHost": "127.0.0.1:7721",
    "KeyCreateTime": "2021-11-09T14:12:36.8431596+08:00"
}
~~~

**注意HTTP请求返回的HTTP状态码，解释请参考“通讯协议”章节。**